##
##  mysql.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_major   3.23
%define       V_minor   54a

#   package information
Name:         mysql
Summary:      Fast Relational Database Management System
URL:          http://www.mysql.com/
Vendor:       MySQL AB
Packager:     The OpenPKG Project
Distribution: OpenPKG [BASE]
Group:        Database
License:      GPL
Version:      %{V_major}.%{V_minor}
Release:      20030103

#   package options
%option       with_berkeleydb  yes
%option       with_innobase    no
%option       with_gemini      no

#   package option decisions
%if "%{with_berkeleydb}" == "yes"
%define       mysql_bdb_cache_size        8M
%define       mysql_bdb_log_buffer_size   32k
%define       mysql_bdb_max_lock          10000
%else
%define       mysql_bdb_cache_size        0
%define       mysql_bdb_log_buffer_size   0
%define       mysql_bdb_max_lock          0
%endif
%if "%{with_berkeleydb}" == "yes" || "%{with_innobase}" == "yes" || "%{with_gemini}" == "yes"
%define       mysqld     mysqld
%else
%define       mysqld     mysqld-max
%endif

#   list of sources
Source0:      http://sunsite.informatik.rwth-aachen.de/mysql/Downloads/MySQL-%{V_major}/mysql-%{version}.tar.gz
Source1:      my.cnf
Source2:      my.pwd
Source3:      rc.mysql
Patch0:       mysql.patch

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20030103, gcc
PreReq:       OpenPKG, openpkg >= 20030103
AutoReq:      no
AutoReqProv:  no

%description
    MySQL is a multi-user Relational Database Management System (RDBMS),
    which is controlled through Structured Query Language (SQL) operating in
    full multi-threading mode. The main goals of MySQL are speed, robustness
    and ease of use. MySQL was originally developed because of the need for
    a SQL server that could handle very big databases with magnitude higher
    speed than what any database vendor could offer.

%prep
    %setup -q
    %patch -p0

%build
    #   determine additional configure options
    case "%{l_target}" in
        *-freebsd* ) opt="--with-client-ldflags=-all-static --with-mysqld-ldflags=-all-static" ;;
        *-linux*   ) opt="--with-client-ldflags=-all-static --with-mysqld-ldflags=-all-static" ;;
        *-solaris* ) opt="" ;; # static compiling doesn't work under Solaris because of missing libdl.a
    esac

    #   configure source tree
    CC="%{l_cc}" \
    CXX="%{l_cxx}" \
    CFLAGS="%{l_cflags -O}" \
    CXXFLAGS="%{l_cxxflags -O}" \
    ./configure \
        --prefix=%{l_prefix} \
        --sysconfdir=%{l_prefix}/etc/mysql \
        --localstatedir=%{l_prefix}/var/mysql \
        --with-unix-socket-path=%{l_prefix}/var/mysql/mysql.sock \
        --with-mysqld-user=%{l_musr} \
        --enable-thread-safe-client \
%if "%{with_berkeleydb}" == "yes"
        --with-berkeley-db \
%endif
%if "%{with_innobase}" == "yes"
        --with-innodb \
%endif
%if "%{with_gemini}" == "yes"
        --with-gemini \
%endif
        --with-low-memory \
        --disable-shared \
        $opt

    #   build source tree
    %{l_make} %{l_mflags -O}

%install
    rm -rf $RPM_BUILD_ROOT

    #   patch init script
    %{l_shtool} subst \
        -e 's;@l_prefix@;%{l_prefix};g' \
        $RPM_BUILD_ROOT%{l_prefix}/scripts/mysql_install_db.sh

    #   perform standard installation procedure
    %{l_make} %{l_mflags} install \
        AM_MAKEFLAGS="DESTDIR=$RPM_BUILD_ROOT" \
        DESTDIR=$RPM_BUILD_ROOT

    #   KLUDGE: my_dir.h is not installed!
    %{l_shtool} install -c -m 644 \
        include/my_dir.h $RPM_BUILD_ROOT%{l_prefix}/include/mysql/

    #   strip installation area
    rm -rf $RPM_BUILD_ROOT%{l_prefix}/mysql-test
    rm -rf $RPM_BUILD_ROOT%{l_prefix}/sql-bench
    rm -f  $RPM_BUILD_ROOT%{l_prefix}/info/dir
    rm -f  $RPM_BUILD_ROOT%{l_prefix}/share/mysql/mysql-%{version}.spec
    rm -f  $RPM_BUILD_ROOT%{l_prefix}/share/mysql/binary-configure
    strip  $RPM_BUILD_ROOT%{l_prefix}/bin/*     2>/dev/null || true
    strip  $RPM_BUILD_ROOT%{l_prefix}/libexec/* 2>/dev/null || true

    #   install global configuration
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/mysql
    %{l_shtool} install -c -m 644 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_rusr@;%{l_rusr};g' \
        -e 's;@mysql_bdb_cache_size@;%{mysql_bdb_cache_size};g' \
        -e 's;@mysql_bdb_log_buffer_size@;%{mysql_bdb_log_buffer_size};g' \
        -e 's;@mysql_bdb_max_lock@;%{mysql_bdb_max_lock};g' \
        %{SOURCE my.cnf} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/mysql/
    %{l_shtool} install -c -m 600 \
        %{SOURCE my.pwd} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/mysql/

    #   install run-command script
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_rusr@;%{l_rusr};g' \
        -e 's;@l_rgrp@;%{l_rgrp};g' \
        -e 's;@mysqld@;%{mysqld};g' \
        %{SOURCE rc.mysql} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   make sure the database directory exists
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/var/mysql

    #   determine the package files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/mysql/my.cnf' \
        '%config %{l_prefix}/etc/mysql/my.pwd'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

%post
    #   create initial database
    $RPM_INSTALL_PREFIX/bin/mysql_install_db
    chown %{l_rusr}:%{l_rgrp} \
        $RPM_INSTALL_PREFIX/etc/mysql/my.cnf \
        $RPM_INSTALL_PREFIX/etc/mysql/my.pwd
    chown -R %{l_rusr}:%{l_rgrp} $RPM_INSTALL_PREFIX/var/mysql/
    ( echo "The MySQL package includes automated maintenance procedures"
      echo "that require administrator access to the database. For this"
      echo "to work you must keep a copy (plain text) of the administrator"
      echo "account in '$RPM_INSTALL_PREFIX/etc/mysql/my.pwd'."
    ) | %{l_rpmtool} msg -b -t notice

